<?php 
class response{
	var $type;
	var $data;	
	function response() {
        $this->type = NULL;
        $this->data = NULL;       
    }
	function response_data($typein,$datain){
		$this->$type=$typein;
		$this->$data=$datain;
	}
}
function translate($word){
	$translations = array(
	"id"=>"ID",
	"caseNumber"=>"Číslo případu",
	"vendor"=>"Prodejce",
	"serialNumber"=>"Sériové číslo",
	"status"=>"Status",
	"productNumber"=>"Produktové číslo",
	"productName"=>"Název produktu",
	"warranty"=>"Záruka",
	"symptomCode"=>"Kód závady",
	"symptomDescription"=>"Popis závady",
	"accessories"=>"Příslušenství",
	"actionProposal"=>"Požadovaný způsob vyřízení",
	"visualAppearance"=>"Visuální stav",
	"repairCode"=>"Kód opravy",
	"shipmentIn"=>"Doprava od prodejce",
	"shipmentOut"=>"Doprava k prodejci",
	"number"=>"Číslo balíku",
	"courier"=>"Dopravce",
	"claimDate"=>"Reklamováno dne",
	"registeredDate"=>"Registrováno dne",
	"receivedDate"=>"Příjato dne",
	"inProgressDate"=>"Oprava dne",
	"quotationDate"=>"Dotaz vznesen dne",
	"quotationAcceptedDate"=>"Dotaz vyřízen dne",
	"delivery"=>"Adresa zákazníka",
	"name"=>"Jméno",
	"street"=>"Ulice",
	"zip"=>"PSČ",
	"city"=>"Město",
	"country"=>"Země",
	"phone"=>"Tel. číslo",
	"email"=>"E-mail",
	"contactPerson"=>"Kontaktní osoba",
	"history"=>"Historie reklamací",
	"type"=>"Typ",
	"material"=>"Součástky",
	"partNumber"=>"Číslo součástky",
	"partName"=>"Název součástky",
	"pieces"=>"Kusů",
	"stock"=>"Sklad",
	"cases"=>"Reklamace",
	"diagnosticMessage"=>"Diagnostická zpráva",
	"engineersMessage"=>"Zpráva technika",
	"result"=>"Výsledek",
	"purchaseDate"=>"Datum zakoupení",
	"finishedDate"=>"Dokončeno dne",
	"departedDate"=>"Odesláno dne",
	"identificationNumber"=>"Identifikační číslo",
	"identifier"=>"Identifikátor",
	"beforeOrderDate"=>"Datum před objednáním",
	"serialNumberNew"=>"Nové sériové číslo",
	"parts"=>"Součástky",
	"error"=>"Chyba",
	""=>"",
	);
	if(!empty($translations[$word]))
		return($translations[$word]);
	else
		return $word;
}
function dmp($in){
	var_dump($in);
}
function output($response,$array_only = false,$cases = false,$history = false){
	if(!$array_only)
		$array = $response->data;
	else
		$array = $response;
	$states = array(
"CR"=>"Created",
"LG"=>"Logged in",
"DI"=>"Diagnostics",
"RW"=>"In Repair",
"RC"=>"Repair completed",
"FT"=>"Final test",
"OK"=>"Repair finished",
"DP"=>"Departed",
"CL"=>"Closed",
"CN"=>"Canceled",
"QP"=>"Question prepared",
"QA"=>"Question awaiting",
"QR"=>"Question resolved",
"BO"=>"Before part order",
"PO"=>"Part ordered",
"PA"=>"Part avaliable",
"RP"=>"Part Requested");
	if(!$array_only){
		switch($response->type){
			case "users":{
				foreach ($array as $row){
					//dmp($row);				
					echo '<h2>'.$row["login"].'</h2><br/>
					<h3>'.$row["firstName"].' '.$row["lastName"].'</h3>';				
				}
				break;
			}
			case "list_range":{
				echo '<p>Počet zobrazených: '.$array["count"].'<br/>
				Celkový počet: '.$array["totalCount"].'<br/>
				Aktuální stránka: '.$array["currentPage"].'<br/>
				Celkový počet stránek :'.$array["pagesCount"].'<br/>			
				</p>';
				$counter = 0;
				if($array["count"]>0) 
				foreach ($array["units"] as $unit){
					echo '<div class="unit">
					<p class="counter">'.$counter.'</p>
					<p>ID zařízení: '.$unit["id"].'<br/>
					ID případu: '.$unit["caseNumber"].'<br/>
					Prodejce: '.$unit["vendor"].'<br/>
					Identifikátor: '.$unit["identifier"].'<br/>
					Sériové číslo: '.$unit["serialNumber"].'<br/>
					Status: '.$unit["status"].' = '.$states[$unit["status"]].'<br/>
					ID případu: '.$unit["id"].'<br/>
					<form type="post" action="single_unit.php">
						<input class="hidden" name="id" value="'.$unit["id"].'"/>
						<button type="submit">Zobrazit detailní informace</button>
					</form>
					';
					if($unit["status"]=="QA")
						$nabidka = CallAPI("GET","http://api.vspdata.cz/price-quotation/",array("caseNumber"=>$unit["caseNumber"]),"price_quotation");
					//var_dump($nabidka);
					if($nabidka->data["error"] == ""&& $nabidka != "")
						echo '
					<form type="post" action="price_quotation.php">
						<input class="hidden" name="caseNumber" value="'.$unit["caseNumber"].'"/>
						<button type="submit">Zobrazit cenové nabídky</button>
					</form>';
					else
						echo '<p>Bez cenové nabídky</p>';
					echo '</div>';
					$counter ++;
				}
				break;
			}
			case "single_unit":{
				$warranty = array(
				"IWV"=>"OK; Záruka prodejce",
				"OOW"=>"NO; Bez záruky",
				"CID"=>"NO; Mechanické poškození",
				"RER"=>"OK; Opakovaná oprava"
				);
				$result = array(
				"REP"=>"Repaired",
				"XCH"=>"Exchanged",
				"ACC"=>"Accessories exchanged",
				"DIA"=>"Diagnostics only",
				"QRE"=>"Quotation rejected",
				"QLE"=>"Quotation lapsed",
				"NTF"=>"No trouble found",
				"NOA"=>"No action (unsupported device)",
				"SCR"=>"Scrapped",
				"CNC"=>"Canceled"
				);
				echo '<div class="single_unit"><p>';
				//var_dump($array);
				foreach ($array as $unit){
					if(!is_array(current($array))){
						if(current($array)!=""){
							if(key($array)=="warranty"){
								if(current($array)!=null)								
									echo '<strong>'.translate(key($array)).':</strong> '.$warranty[current($array)].'<br/>';
								else 
									echo '<strong>'.translate(key($array)).":</strong> Žádná data";
							}								
							else if(key($array)=="result"){
								if(current($array)!=null)								
									echo '<strong>'.translate(key($array)).':</strong> '.$result[current($array)].'<br/>';
								else 
									echo '<strong>'.translate(key($array)).":</strong> Žádná data";
							}								
							else{
								echo '<strong>'.translate(key($array)).':</strong> '.current($array).'<br/>';
							}
						}							
					}
					else if(sizeof(current($array))>0){	
						echo "</p>";
						echo '<p><strong>'.translate(key($array)).'</strong></p>';
						//var_dump($array);
						if(key($array)=="history"){
							//var_dump(current($array));
							output(current($array),true,false,$array["caseNumber"]);
						}
						else
							output(current($array),true);
							
					}
					next($array);
				}
				echo '</div>'; 
				break;
			}	
			case "price_quotation":{
				if($array["count"]!="")
					echo '<p>Počet zobrazených: '.$array["count"].'<br/></p>';
				else
					echo '<p>Žádná data.</p>';
					
				$counter = 0;
				if($array["count"]>0){					
					foreach ($array["case"] as $unit){
						echo '<div class="unit">
						<br/>
						<p class="counter">'.$counter.'</p>
						<p>Číslo reklamace: '.key($array["case"]).'<br/>
						Cena: '.$unit["price"].'<br/>
						Měna: '.$unit["currency"].'<br/>';
						echo '
						<form type="post" action="price_quotation_decide.php">
							<select name="decision">
								<option value="QPA"><span style="color:green;">Potvrdit</span></option>
								<option value="QPR"><span style="color:red;">Odmítnout</span></option>
							</select>
							<input class="hidden" name="price" value="'.$unit["price"].'"/>
							<input class="hidden" name="caseNumber" value="'.key($array["case"]).'"/>						
							<button type="submit">Odeslat rozhodnutí</button>
						</form>
						</div>';
						$counter ++;
					}
				}
				
				break;
			}
			case "part_stock_levels":{
				$states = array(
					"BO"=>"Before part order",
					"PO"=>"Part ordered",
					"PA"=>"Part avaliable",
					"RP"=>"Part Requested");
				echo '<div class="single_unit">';
				foreach ($array as $part){
					if(!is_array(current($array)))
						echo '<strong>'.translate(key($array)).':</strong> '.current($array).'<br/>';
					else{
						echo '<strong>'.translate(key($array)).':</strong> ';
						if(key($array)!="cases")
							output(current($array),true);
						else
							output(current($array),true,true,false);
					}
					next($array);
				}
				echo '</div>';
				break;
			}
			case "part_use_period":{
				$states = array(
					"BO"=>"Before part order",
					"PO"=>"Part ordered",
					"PA"=>"Part avaliable",
					"RP"=>"Part Requested");
				echo '<div class="part_use_period">';
				$number = null;
				foreach ($array as $part){
					if(key($array)=="caseNumber")
						$number = current($array);
					if(!is_array(current($array)))
						echo '<strong>'.translate(key($array)).':</strong> '.current($array).'<br/>';
					else{
						echo '<strong>'.translate(key($array)).':</strong> ';
						if(key($array)!="cases")
							output(current($array),true);
						else
							output(current($array),true,true,$array["caseNumber"]);
					}
					next($array);
				}
				echo '</div>';
				break;
			}
			
		} 
		
	}
	else if (!$cases){
		echo '<ul>';
		//var_dump($history);
		$vypsano = false;
		$number = null;
		if(is_array($array))
		foreach ($array as $unit){
			if(!is_array(current($array))&&sizeof(current($array))>0){
				if(current($array)!=""){	
					echo '<li><strong>'.translate(key($array)).':</strong> '.current($array).'</li>';	
					if((string)key($array)=="caseNumber"){
							$number = current($array);
					}
				}
			}
			else if (sizeof(current($array))>0){
				echo '</ul>';
				if($history!=false){
					output(current($array),true,true,$history);
					if(!$vypsano){
						echo "<p>Celkový počet reklamací: " .sizeof($array)."</p>";
						$vypsano = true;
					}
				}
				else
					output(current($array),true);
			}
			if($number!=null){
					echo '<form type="post" action="single_unit.php">
								<input class="hidden" name="id" value="'.$number.'"/>
								<button type="submit">Zobrazit detailní informace</button>
								</form>';	
					$number = null;
				}
			
			next($array);
		}
		echo '</ul>';
	}
	else{
		echo '<ul>';
		if(is_array($array)){
			$number = false;
			foreach ($array as $unit){
				if(!is_array(current($array))&&sizeof(current($array))>0){
					if(current($array)!="") {
						if($history!=false){
							//echo $number;
							if($array["caseNumber"]!=$history){
								if((string)key($array)=="caseNumber")
									$number=current($array);
								echo '<li><strong>'.translate(key($array)).':</strong> '.current($array).'</li>';			
							}
							else{
								//echo '<li><strong>'.translate(key($array)).':</strong> '.current($array).'</li>';						
							}								
						}
						else{
							echo '<li><strong>'.translate(key($array)).':</strong> '.current($array).'</li>';
							echo '<form type="post" action="single_unit.php">
								<input class="hidden" name="id" value="'.current($array).'"/>
								<button type="submit">Zobrazit detailní informace</button>
								</form>';					
						}  
					}
				}
				else if (sizeof(current($array))>0){				
					echo '</ul>';
					output(current($array),true);
				}
				next($array);
			}
		}
		if($number!=false){
					echo '<form type="post" action="single_unit.php">
								<input class="hidden" name="id" value="'.$number.'"/>
								<button type="submit">Zobrazit detailní informace</button>
								</form>';	
					$number= false;
				}
		echo '</ul>';
	}
		
}
function CallAPI($method, $url, $data2 = false,$type)
{
	$data = array();
    $ch = curl_init();
	$max = sizeof($data2);
	$token = $_SESSION["token"];
	$encoded_token = base64_encode("auth:".$token);		
	$headers = array('X-Connect-To: dev','Content-Type: application/json','Authorization: Basic '.$encoded_token.'');
	/*delete empty values from query string or if select == none*/
	for($i = 0; $i < $max;$i++) {
		if(current($data2)!="" && current($data2)!="none"){
			$data[key($data2)] = current($data2);
		}
		next($data2); 
	}
	/*decidet which way to go depending on cURL method*/
    switch ($method)
    {
        case "POST":
            curl_setopt($ch, CURLOPT_POST, 1);			
            if ($data)
                curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
            break;
        case "PUT":            
			//curl_setopt($ch, CURLOPT_PUT, 1);			
			curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");			
			if($data){							
				curl_setopt($ch, CURLOPT_POSTFIELDS,json_encode($data));				
			}			
            break;
        default:           
			if ($data)
				if ($type != "single_unit" && $type != "price_quotation")
					$url = sprintf("%s?%s", $url, http_build_query($data));
				else if ($data["caseNumber"]=="" && $data["id"]=="")
					$url = sprintf("%s?%s", $url, http_build_query($data));			
				else if ($data["caseNumber"]!="")
					$url .= "/".$data["caseNumber"];
				else if ($data["id"]!= "")
					$url .= "/".$data["id"];
				else if($type == "price_quotation" && $data == "")
					;
				
    }
	dmp($url);	
    /* Optional Authentication:*/
	/*new response object*/
	$resp = new response();
	$resp->type = $type;	
	/*get security token*/
	
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
	curl_setopt($ch, CURLOPT_USERPWD, "auth:$token");
	curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	
	$curl_response = curl_exec($ch);
	//print_r($curl_response);
	curl_close($ch);
	$_SESSION["curl_response"] = $curl_response;
	$resp->data = JSON_decode($curl_response,true);
	if($_SESSION["history"] == null)
		$_SESSION["history"] = array();
	if($resp->data != null && empty($resp->data["error"])){
		if(sizeof($_SESSION["history"])>9)
			array_shift($_SESSION["history"]);
		array_push($_SESSION["history"],$resp);
		$_SESSION["current_index"] = sizeof($_SESSION["history"])-1;
	}
	//$_SESSION["previous_response"] = $_SESSION["curl_response"];
	//var_dump($resp->data);
	return $resp;
}
?>